import os
import linuxcnc
import hal

class HandlerClass:

    def __init__(self, halcomp,widgets,paths):
        self.hal = halcomp
        self.w = widgets
        INIPATH = os.environ.get('INI_FILE_NAME', '/dev/null')
        self.inifile = linuxcnc.ini(INIPATH)

    def initialized__(self):
        mode = 'mode_{}'.format(self.inifile.find('PLASMAC', 'MODE') or 0)
        self.w[mode].setChecked(True)

    def mode_toggled(self, data):
        m0_onn = [self.w.arc_voltage_in, self.w.arc_voltage_out, self.w.arc_voltage_label, self.w.arc_voltage_line]
        m0_off = [self.w.arc_ok, self.w.arc_ok_label, self.w.arc_ok_line, \
                  self.w.move_up, self.w.move_down, self.w.move_label, self.w.move_line]
        m1_onn = [self.w.arc_voltage_in, self.w.arc_voltage_out, self.w.arc_voltage_label, self.w.arc_voltage_line, \
                  self.w.arc_ok, self.w.arc_ok_label, self.w.arc_ok_line]
        m1_off = [self.w.move_up, self.w.move_down, self.w.move_label, self.w.move_line]
        m2_onn = [self.w.move_up, self.w.move_down, self.w.move_label, self.w.move_line]
        m2_off = [self.w.arc_voltage_in, self.w.arc_voltage_out, self.w.arc_voltage_label, self.w.arc_voltage_line]
        if self.w.sender().text()[0] == '0':
            for widget in m0_off: widget.hide()
            for widget in m0_onn: widget.show()
        elif self.w.sender().text()[0] == '1':
            for widget in m1_off: widget.hide()
            for widget in m1_onn: widget.show()
        elif self.w.sender().text()[0] == '2':
            for widget in m2_off: widget.hide()
            for widget in m2_onn: widget.show()
        hal.set_p('plasmac.mode', self.w.sender().text()[0])

    def __getitem__(self, item):
        return getattr(self, item)
    def __setitem__(self, item, value):
        return setattr(self, item, value)

def get_handlers(halcomp,widgets,paths):
     return [HandlerClass(halcomp,widgets,paths)]
